#include "codetab.h"
#include "mainwindow.h"
#include <QHBoxLayout>
#include <QWidget>
#include <QFile>
#include <QTabWidget>
#include <QDir>

CodeTab::CodeTab(): saved(true) {
	QHBoxLayout *layout = new QHBoxLayout;
	codeEditor = new CodeEditor;

	layout->addWidget(codeEditor);
	setLayout(layout);
}

CodeTab::CodeTab(QTabWidget *tabWidget): tabWidget(tabWidget), saved(true) {
	QHBoxLayout *layout = new QHBoxLayout;
	codeEditor = new CodeEditor;

	layout->addWidget(codeEditor);
	setLayout(layout);
}

CodeTab::CodeTab(QTabWidget *tabWidget, QString path): tabWidget(tabWidget), saved(true) {
	QHBoxLayout *layout = new QHBoxLayout;
	codeEditor = new CodeEditor;

	layout->addWidget(codeEditor);
	setLayout(layout);

	QFile file(path);
	if (file.open(QFile::ReadOnly | QFile::Text)) {
		codeEditor->setPlainText(file.readAll());
	}
	filepath = path;
	filename = path.section('/', -1);
}

void CodeTab::save() {
	QFile file(filepath);
	if (file.open(QFile::WriteOnly | QFile::Text)) {
		QString data = codeEditor->toPlainText();
		file.write(data.toAscii(), data.length());
		file.close();
	}
}

void CodeTab::setFilePath(QString path) {
	filepath = path;
	filename = path.section('/', -1);

	tabWidget->setTabText(tabWidget->indexOf(this), filename);
}

QString CodeTab::getDirectory() {
	if (filepath != QString()) {
		return filepath.left(filepath.lastIndexOf(filename));
	}
	else {
		return QDir::currentPath() + "/";
	}
}
