#ifndef CODETAB_H
#define CODETAB_H

#include <QWidget>
#include "codeeditor.h"

class QTabWidget;

class CodeTab : public QWidget {
	Q_OBJECT
	public:
		CodeTab();
		CodeTab(QTabWidget *tabWidget);
		CodeTab(QTabWidget *tabWidget, QString file);

		void save();

		QString getFileName() const { return filename; }
		QString getFilePath() const { return filepath; }
		QString getDirectory();

		CodeEditor *getCodeEditor() { return codeEditor; }

		bool isSaved() const { return saved; }

		void setFilePath(QString);
		void setTabWidget(QTabWidget *tabWidget) { this->tabWidget = tabWidget; }
	private:
		QString filepath;
		QString filename;

		CodeEditor *codeEditor;

		QTabWidget *tabWidget;

		bool saved;
};

#endif
