#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QSessionManager>
#include <QSettings>
#include "ui_mainwindow.h"
#include "highlighter.h"
#include "codetab.h"

class MainWindow : public QMainWindow, private Ui::MainWindow {
	Q_OBJECT
	public:
		MainWindow(QWidget *parent = 0, Qt::WFlags flags = 0);
		~MainWindow();
	protected:
		void closeEvent(QCloseEvent *event);
	private:	
		QSettings mainSettings;
		QSyntaxHighlighter *highlighter;

		void LoadSettings();
		void SaveSettings();

		bool CloseTab(CodeTab *codeTab);

		void OpenFile(QString path);
		bool SaveFileAs(CodeTab *codeTab);
		bool SaveFile(CodeTab *codeTab);

		bool ConfirmSave(CodeTab *codeTab);
	private slots:
		void handleActionNew();
		void handleActionOpen();
		void handleActionSave();
		void handleActionSave_As();
		void handleActionSave_All();
		void handleActionClose();
		void handleActionClose_All();

		void handleActionUndo();
		void handleActionRedo();
		void handleActionCut();
		void handleActionCopy();
		void handleActionPaste();
		void handleActionSelect_All();

		void handleActionCheck_Syntax();
		void handleActionCompile_and_RUN();
		void handleActionBuild_EXE();

		void handleHomeButton();
};

#endif
